#include <M5Stack.h>
#include <Wire.h>
#include <WiFi.h>
#include <WiFiUDP.h>
#define FACES_KEYBOARD_I2C_ADDR 0x08
#define SSID "**********"     // 無線LANアクセスポイントのSSID
#define PASS "**********"     // パスワード
static WiFiUDP udp; 
static const int rport = 9000; //送信先のポート
static const int lport = 7000;  //自身のポート
String str="";
String str2="";
String lip="192.168.64.xx";
String msg[]={"","","",""};
int lmsg=4;
String res[]={"","","",""};
int lres=4;
int lptr=0;
int lptr2=0;
int rp[]={192,168,64,40};
String rip="";
char ripc[50];
int setM=0;

void drawLcd() {
  M5.Lcd.clear();
  M5.Lcd.setTextSize(2);
  M5.Lcd.setTextColor(TFT_YELLOW,TFT_BLACK);
  M5.Lcd.setCursor(0,0); M5.Lcd.print("[ M52WAY COMMUNICATION A ]");
  M5.Lcd.setCursor(0,20); M5.Lcd.print(" Receiver Setting Mode:"+String(setM));
  rip=String(rp[0])+"."+String(rp[1])+"."+String(rp[2])+"."+String(rp[3]);
  M5.Lcd.setCursor(0,40); M5.Lcd.print(" ReceiverIP:"+rip);
  M5.Lcd.setCursor(0,60); M5.Lcd.print(" MySenderIP:"+lip);
  M5.Lcd.setTextColor(TFT_GREEN,TFT_BLACK);
  for (int i=0; i<lmsg; i++) {
    M5.Lcd.setCursor(0,20*i+80); M5.Lcd.print(msg[i]);
  }
  M5.Lcd.setTextColor(TFT_RED,TFT_BLACK);
  for (int i=0; i<lres; i++) {
    M5.Lcd.setCursor(0,20*i+160); M5.Lcd.print(res[i]);
  }
}

void lScroll() {                           // 送信スクロール
  if(lptr>lmsg-1){                         
    for (int i=0; i<lmsg-1; i++) {            
      msg[i]=msg[i+1];
    }
    lptr=lmsg-1;
  }  
}

void lScroll2() {                           // 受信スクロール
  if(lptr2>lres-1){                         
    for (int i=0; i<lres-1; i++) {            
      res[i]=res[i+1];
    }
    lptr2=lres-1;
  }  
}

void setup() {
  M5.begin();
  Wire.begin();
  WiFi.mode(WIFI_STA);                    // 無線LANをSTAモードに設定
  WiFi.begin(SSID,PASS);                  // 無線LANアクセスポイントへ接続
  while(WiFi.status() != WL_CONNECTED){   // 接続に成功するまで待つ
    delay(500);                           // 待ち時間処理
  }
  lip=WiFi.localIP().toString();
  drawLcd();

  while(1){
    if(M5.BtnA.wasPressed()){
      ++setM; if (setM>4) setM=0;
      drawLcd();
    } else if (M5.BtnB.wasPressed() && setM<4 && rp[setM]>0 ){
      --rp[setM]; drawLcd();
    } else if (M5.BtnC.wasPressed() && setM<4 && rp[setM]<255){
      ++rp[setM]; drawLcd();
    } else if (setM==4 && (M5.BtnB.wasPressed() || M5.BtnC.wasPressed())){
      break;
    }
    M5.update();
    delay(100);
  }
  rip.toCharArray(ripc,50);
  delay(500);
  msg[lptr]="<";
  res[lptr2]=">";
  drawLcd();
  udp.begin(lport); 
}

void loop() {
  char buf[50];
  int len;                                // 文字列長を示す整数型変数を定義
  memset(buf, 0, 50);                     // 文字列変数bufの初期化(20バイト)
  len = udp.parsePacket();                // 受信パケット長を変数lenに代入
  if(len>0) {                      
    udp.read(buf, 50);                    // 受信文字列を変数bufに格納する
    str2=buf;
    lScroll2();
    res[lptr2++]=">"+str2;
    drawLcd();
    lScroll2();
    str2="";
    res[lptr2]=">";
    drawLcd();
    delay(500);
  }

  Wire.requestFrom(FACES_KEYBOARD_I2C_ADDR, 1);
  int c;
  if (Wire.available()) {
    c = Wire.read(); // receive a byte as character
    if (c>31  && c <128) {     
      str +=(char)c;
      msg[lptr]="<"+str;
      drawLcd();
    } else if (c==10) {
      udp.beginPacket(ripc,rport);        // 送信パケットの開始
      char buf[35];                       // 送信文字列配列bufの宣言
      char chr;
      memset(buf,0,50);                   // bufの全ての文字を0で初期化
      int len=str.length();               // 送信メッセージの文字数をlenに代入
      str.toCharArray(buf,50);            // 送信メッセージを配列bufに格納
      for (int i=0; i<len+1; i++) {
        chr=buf[i];
        udp.write(chr);                   // 送信メッセージを１文字ごとに送信
      }
      udp.endPacket();                    // 送信パケットの終了
      delay(300);
      lScroll();
      msg[lptr++]="<"+str;
      drawLcd();
      lScroll();
      str="";
      msg[lptr]="<";
      drawLcd();
    } else if (c==8){
      str=str.substring(0,str.length()-1);
      msg[lptr]="<"+str;
      drawLcd();
    }
    delay(300);
  }
}
